import type { AccountData } from "@cardinal/common";
import * as web3 from "@solana/web3.js";
import type { ClaimRequestData, EntryData, NamespaceData, ReverseEntryData } from ".";
export declare function getNamespaceByName(connection: web3.Connection, namespaceName: string): Promise<AccountData<NamespaceData>>;
export declare function getNamespace(connection: web3.Connection, namespaceId: web3.PublicKey): Promise<AccountData<NamespaceData>>;
export declare function getNamespaces(connection: web3.Connection): Promise<AccountData<NamespaceData>[]>;
export declare function getNameEntry(connection: web3.Connection, namespaceName: string, entryName: string): Promise<AccountData<EntryData>>;
export declare function getNameEntries(connection: web3.Connection, namespaceName: string, entryNames: string[]): Promise<(AccountData<EntryData> & {
    name: string;
})[]>;
export declare function getClaimRequest(connection: web3.Connection, namespaceName: string, entryName: string, requestor: web3.PublicKey): Promise<AccountData<ClaimRequestData>>;
export declare function getPendingClaimRequests(connection: web3.Connection): Promise<AccountData<ClaimRequestData>[]>;
export declare function getReverseEntry(connection: web3.Connection, pubkey: web3.PublicKey): Promise<AccountData<ReverseEntryData>>;
export declare function tryGetReverseEntry(connection: web3.Connection, pubkey: web3.PublicKey): Promise<AccountData<ReverseEntryData> | null>;
//# sourceMappingURL=accounts.d.ts.map