import type { AnchorTypes } from "@saberhq/anchor-contrib";
import { PublicKey } from "@solana/web3.js";
import * as NAMESPACES_TYPES from "./idl/cardinal_namespaces";
export declare const NAMESPACES_PROGRAM_ID: PublicKey;
export declare const METADATA_CONFIG_SEED = "metadata-config";
export declare type NAMESPACES_PROGRAM = NAMESPACES_TYPES.Namespaces;
export declare const NAMESPACES_IDL: NAMESPACES_TYPES.Namespaces;
export declare type NamespacesTypes = AnchorTypes<NAMESPACES_PROGRAM>;
declare type Accounts = NamespacesTypes["Accounts"];
export declare type GlobalContextData = Accounts["globalContext"];
export declare type NamespaceData = Accounts["namespace"];
export declare type EntryData = Accounts["entry"];
export declare type ReverseEntryData = Accounts["reverseEntry"];
export declare type ClaimRequestData = Accounts["claimRequest"];
export declare const GLOBAL_RENTAL_PERCENTAGE = 0.2;
export declare const GLOBAL_CONTEXT_SEED = "context";
export declare const NAMESPACE_SEED = "namespace";
export declare const ENTRY_SEED = "entry";
export declare const REVERSE_ENTRY_SEED = "reverse-entry";
export declare const CLAIM_REQUEST_SEED = "rent-request";
export {};
//# sourceMappingURL=constants.d.ts.map